'use strict';

const path = require('path');
const defu2 = require('defu');
const ms2 = require('ms');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

const defu2__default = /*#__PURE__*/_interopDefaultLegacy(defu2);
const ms2__default = /*#__PURE__*/_interopDefaultLegacy(ms2);

var name = "@nuxtjs/strapi";
var version = "0.1.11";

const defaults = {
  url: process.env.STRAPI_URL || "http://localhost:1337",
  entities: [],
  key: "strapi_jwt",
  expires: "session",
  cookie: {}
};
async function strapiModule(moduleOptions) {
  const {nuxt} = this;
  const options = defu2__default['default'](moduleOptions, nuxt.options.strapi, defaults);
  if (typeof options.expires === "string" && options.expires !== "session") {
    options.expires = ms2__default['default'](options.expires);
  }
  nuxt.options.publicRuntimeConfig = nuxt.options.publicRuntimeConfig || {};
  nuxt.options.publicRuntimeConfig.strapi = nuxt.options.publicRuntimeConfig.strapi || {};
  nuxt.options.publicRuntimeConfig.strapi.url = options.url;
  const runtimeDir = path.resolve(__dirname, "runtime");
  nuxt.options.alias["~strapi"] = runtimeDir;
  nuxt.options.build.transpile.push(runtimeDir, "destr", "requrl", "hookable", "ufo");
  this.addPlugin({
    src: path.resolve(runtimeDir, "plugin.js"),
    fileName: "strapi.js",
    options
  });
  await this.requireModule("@nuxt/http");
  await this.requireModule("cookie-universal-nuxt");
}
strapiModule.meta = {name, version};

module.exports = strapiModule;
